<?php

namespace ShineSoftware\Constriv\Block\Hosted;

use Magento\Framework\View\Element\Template\Context;
use Magento\Payment\Block\Form as BlockForm;
use Magento\Store\Model\ScopeInterface;
use ShineSoftware\Constriv\Model\Config;

class Form extends BlockForm {

    /**
     * @var Config
     */
    protected $_modelConfig;

    public function __construct(Context $context, Config $modelConfig, array $data = []) {
        $this->_modelConfig = $modelConfig;

        parent::__construct($context, $data);
    }

    protected function _construct() {
        $locale = Mage::app()->getLocale();
        $mark = Mage::getConfig()->getBlockClassName('core/template');
        $mark = new $mark;
        $mark->setTemplate('ShineSoftware_Constriv::constriv/hosted/mark.phtml')
                ->setHelpUrl($this->_getConfig()->getPaymentHelpUrl($locale))
                ->setLogoUrl($this->_getConfig()->getPaymentLogoUrl('hosted', $locale->getLocaleCode()));
        $this->setTemplate('ShineSoftware_Constriv::constriv/hosted/form.phtml')
                ->setMethodTitle('')
                ->setMethodLabelAfterHtml($mark->toHtml());
        return parent::_construct();
    }

    protected function _getConfig() {
        return $this->_modelConfig;
    }

    public function getCheckoutOptionDescription() {
        $description = $this->_scopeConfig->getValue('payment/constriv_hosted_base_settings/checkout_description', ScopeInterface::SCOPE_STORE);
        if (!empty($description)) {
            return __($this->_scopeConfig->getValue('payment/constriv_hosted_base_settings/checkout_description', ScopeInterface::SCOPE_STORE));
        } else {
            return __('Select this option to pay by Credit Card!');
        }
    }

}

;
