<?php

namespace ShineSoftware\Constriv\Gateway\Validator;

use Magento\Payment\Gateway\Validator\AbstractValidator;
use Magento\Payment\Gateway\Validator\ResultInterface;

class AuthorizeValidator extends AbstractValidator {

    public function validate(array $validationSubject) {
        if (!isset($validationSubject['response']) || !is_array($validationSubject['response'])) {
            throw new \InvalidArgumentException('Response does not exist');
        }
        $response = $validationSubject['response'];
        
        if ($this->isSuccessfulTransaction($response)) {
            return $this->createResult(
                            true, []
            );
        } else {
            
            return $this->createResult(
                            false, [__($response['errorMessage'])]
            );
        }
    }

    private function isSuccessfulTransaction(array $response) {
        return isset($response['error']) && $response['error'] == FALSE;
    }

}

;
