jQuery(document).ready(function ($j) {

    $j("#constriv_moto_cc_number").keyup(function (e) {

        $j("#credit-card-type li").removeClass("active");
        $j("input[id=constriv_moto_cc_type]").val('');

        switch (getCreditCardTypes(this.value)) {
            case 'visa':
                $j('#credit-card-type .VI').addClass('active');
                $j("input[id=constriv_moto_cc_type]").val('VI');
                break;
            case 'mastercard':
                $j('#credit-card-type .MC').addClass('active');
                $j("input[id=constriv_moto_cc_type]").val('MC');
                break;
            case 'amex':
                $j('#credit-card-type .AE').addClass('active');
                $j("input[id=constriv_moto_cc_type]").val('AE');
                break;
            case 'discover':
                $j('#credit-card-type .DI').addClass('active');
                $j("input[id=constriv_moto_cc_type]").val('DI');
                break;
        }
    });

    function getCreditCardTypes(val) {

        if(!val || !val.length) return undefined;

        var type = new Array;
        type[1] = '^4[0-9]{12}(?:[0-9]{3})?$';                          // visa
        type[2] = '^5[1-5][0-9]{14}$';                                  // mastercard
        type[3] = '^65[4-9][0-9]{13}|64[4-9][0-9]{13}|6011[0-9]{12}|(622(?:12[6-9]|1[3-9][0-9]|[2-8][0-9][0-9]|9[01][0-9]|92[0-5])[0-9]{10})$';// Discover Card
        type[4] = '^3[47][0-9]{13}$';                                   // amex
        type[5] = '^(5018|5020|5038|6304|6759|6761|6763)[0-9]{8,15}$'; // Maestro Card
        type[6] = '^(6334|6767)[0-9]{12}|(6334|6767)[0-9]{14}|(6334|6767)[0-9]{15}$';// Solo Card

        //type[7] = '^389[0-9]{11}$';                                     // Carte Blanche Card
        //type[8] = '^3(?:0[0-5]|[68][0-9])[0-9]{11}$';                   // Diners Club Card
        //type[9] = '^(?:2131|1800|35\d{3})\d{11}$';                      // JCB
        //type[10] = '^63[7-9][0-9]{13}$';                                 // Insta Payment Card
        //type[11] = '^(6304|6706|6709|6771)[0-9]{12,15}$';                // Laser Card
        //type[12] = '^(62[0-9]{14,17})$';                                // Union Pay Card
        //type[13] = '^9[0-9]{15}$';                                      // KoreanLocalCard
        //type[14] = '^(6541|6556)[0-9]{12}$';                            // BCGlobal

        var ccnum = val.replace(/[^\d.]/g, '');
        var returntype = 0;

        $j.each(type, function(idx, re) {
            var regex = new RegExp(re);
            if(regex.test(ccnum) && idx>0) {
                returntype = idx;
            }
        });
        returntype = parseInt(returntype);
        console.log('returntype: '+returntype);
        switch(returntype) {
            case 0: return undefined;
            case 1: return 'visa';
            case 2: return 'mastercard';
            case 3: return 'discover';
            case 4: return 'amex';
            case 5: return 'maestro';
            case 6: return 'solo';
        };

        return undefined;
    }
});